package dev.peerat.mapping;

import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Map.Entry;
import java.util.Set;

import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.Messager;
import javax.annotation.processing.RoundEnvironment;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.tools.Diagnostic.Kind;

import javax.tools.FileObject;
import javax.tools.StandardLocation;

public class TreasureProcessor extends AbstractProcessor {
	
	@Override
	public boolean process(Set<? extends TypeElement> annotations, RoundEnvironment roundEnv){
		
		Messager messager = processingEnv.getMessager();
		
	    for(TypeElement annotation : annotations){
	    	for(Element element : roundEnv.getElementsAnnotatedWith(annotation)){
	    		messager.printMessage(Kind.WARNING, "["+roundEnv.processingOver()+"] I tried", element);
	    		for(Entry<String, String> opt : processingEnv.getOptions().entrySet()){
	    			messager.printMessage(Kind.WARNING, opt.getKey()+" -> "+opt.getValue(), element);
	    		}
	    		
	    		File file = null;
	    		try {
	    			FileObject resource = processingEnv.getFiler().getResource(StandardLocation.SOURCE_OUTPUT, "", "");
	    			File clazz = new File(resource.toUri().toString().substring(6)+"/be/jeffcheasey88/peeratcode/model/Badge.class");
	    			if(clazz.exists()){
	    				messager.printMessage(Kind.WARNING, "["+roundEnv.processingOver()+"] I was created it", element);
	    				return true;
	    			}
	    			
	    			file = new File(resource.toUri().toString().substring(6)+"/be/jeffcheasey88/peeratcode/model/Badge.java");
	    			if(!file.exists()){
	    				File parent = file.getParentFile();
	    				if(!parent.exists()) parent.mkdirs();
	    				file.createNewFile();
	    			}
	    			
		            Writer writer = new FileWriter(file);
		            writer.append("package be.jeffcheasey88.peeratcode.model;\n\n");
		            writer.append("public class Badge extends TreasureInABottle{\n");
		            writer.append("public Badge(){}\n");
		            writer.append("public static int getBadge(int player){ return context; }\n");
		            writer.append("}\n");
		            writer.flush();
		            writer.close();
		            
		            Process p = Runtime.getRuntime().exec("javac be/jeffcheasey88/peeratcode/model/Badge.java", new String[0], new File("C:\\Users\\jeffc\\eclipse-workspace\\peer-at-code-backend\\.generated"));
		            p.waitFor();
		            
		            file.delete();
		            
		            messager.printMessage(Kind.WARNING, "["+roundEnv.processingOver()+"] We created it !", element);
		        } catch (Exception e) {
		            e.printStackTrace();
		            messager.printMessage(Kind.WARNING, "["+roundEnv.processingOver()+"] We not created it ! ("+file+") "+e.getMessage(), element);
		        }
	    	}
	    }
	    
	    return true;
	  }
	
	@Override
	public Set<String> getSupportedAnnotationTypes(){
		return new HashSet<>(Arrays.asList(Treasure.class.getCanonicalName()));
	}
	
	@Override
	public SourceVersion getSupportedSourceVersion(){
		return SourceVersion.RELEASE_8;
	}
}